Summary: The basic directory layout for a Linux system.
Name: filesystem
Version: 2.4.0
Release: 3.el5.centos
License: Public Domain
URL: https://fedorahosted.org/filesystem
Group: System Environment/Base
Buildroot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Source1: https://fedorahosted.org/filesystem/browser/lang-exceptions
Prereq: setup >= 2.5.4-1
BuildRequires: iso-codes

%description
The filesystem package is one of the basic packages that is installed
on a CentOS system. Filesystem contains the basic directory
layout for a Linux operating system, including the correct permissions
for the directories.

%prep
rm -f $RPM_BUILD_DIR/filelist

%install
rm -rf %{buildroot}
mkdir %{buildroot}

cd %{buildroot}

mkdir -p mnt/{floppy,cdrom} \
	bin boot dev \
	etc/{X11/{applnk,sysconfig,serverconfig},opt,xinetd.d,skel,sysconfig,pki} \
	home lib/modules %{_lib} media mnt opt proc root sbin selinux srv sys tmp \
        usr/{bin,etc,games,include,%{_lib}/{games,gcc-lib,sse2,tls,X11},lib/{games,gcc-lib,locale,X11},libexec,local/{bin,etc,games,lib,%{_lib},sbin,src,share/{man/man{1,2,3,4,5,6,7,8,9,n,1x,2x,3x,4x,5x,6x,7x,8x,9x},info},libexec,include,},sbin,share/{applications,doc,dict,games,info,icons,man/man{1,2,3,4,5,6,7,8,9,n,1x,2x,3x,4x,5x,6x,7x,8x,9x,0p,1p,3p},doc,misc,empty,pixmaps,xsessions},src/{debug,kernels}} \
        var/{empty,lib/{games,misc},local,lock/subsys,log,nis,preserve,run,spool/{mail,lpd},tmp,db,cache,opt,games,yp}

ln -snf ../var/tmp usr/tmp
ln -snf spool/mail var/mail

grep -v "^$" /usr/share/iso-codes/iso_639.tab | grep -v "^#" | while read a b c d ; do
	[[ "$d" =~ "^Reserved" ]] && continue
	[[ "$d" =~ "^No linguistic" ]] && continue

	locale=$c
	if [ "$locale" = "XX" ]; then
		locale=$b
	fi
	echo "%lang(${locale})	/usr/share/locale/${locale}" >> $RPM_BUILD_DIR/filelist
  echo "%lang(${locale}) %ghost %config(missingok) /usr/share/man/${locale}" >>$RPM_BUILD_DIR/filelist
done
cat %{SOURCE1} | grep -v "^#" | grep -v "^$" | while read loc ; do
	locale=$loc
	locality=
  special=
	[[ "$locale" =~ "@" ]] && locale=${locale%%@*}
	[[ "$locale" =~ "_" ]] && locality=${locale##*_}
  [[ "$locality" =~ "." ]] && locality=${locality%%.*}
  [[ "$loc" =~ "_" ]] || [[ "$loc" =~ "@" ]] || special=$loc


	# If the locality is not official, skip it
	if [ -n "$locality" ]; then
		grep -q "^$locality" /usr/share/iso-codes/iso_3166.tab || continue
	fi
  # If the locale is not official and not special, skip it
  if [ -z "$special" ]; then
      egrep -q "[[:space:]]${locale%_*}[[:space:]]" \
        /usr/share/iso-codes/iso_639.tab || continue
  fi
	echo "%lang(${locale})	/usr/share/locale/${loc}" >> $RPM_BUILD_DIR/filelist
  echo "%lang(${locale})  %ghost %config(missingok) /usr/share/man/${loc}" >> $RPM_BUILD_DIR/filelist
done


cat $RPM_BUILD_DIR/filelist | grep "locale" |  while read a b ; do
	mkdir -p -m 755 %{buildroot}/$b/LC_MESSAGES
done

cat $RPM_BUILD_DIR/filelist | grep "/share/man" | while read a b c d; do
    mkdir -p -m 755 %{buildroot}/$d/man{1,2,3,4,5,6,7,8,9,n,1x,2x,3x,4x,5x,6x,7x,8x,9x,0p,1p,3p}
done

for i in `echo man{1,2,3,4,5,6,7,8,9,n,1x,2x,3x,4x,5x,6x,7x,8x,9x,0p,1p,3p}`; do
   echo "/usr/share/man/$i" >>$RPM_BUILD_DIR/filelist
done

%clean
rm -rf %{buildroot}

%files -f filelist
%defattr(0755,root,root)
%dir /
/bin
/boot
/dev
/etc
/home
/lib
%ifarch x86_64 ppc ppc64 sparc sparc64 s390 s390x
/%{_lib}
%endif
/media
%dir /mnt
%ghost %config(missingok) %verify(not size md5 mode user link rdev group mtime) /mnt/cdrom
%ghost %config(missingok) %verify(not size md5 mode user link rdev group mtime) /mnt/floppy
%dir /opt
%attr(555,root,root) /proc
%attr(750,root,root) /root
/sbin
/selinux
/srv
/sys
%attr(1777,root,root) /tmp
%dir /usr
/usr/[^s]*
/usr/sbin
%dir /usr/share
/usr/share/applications
/usr/share/doc
/usr/share/dict
/usr/share/games
%attr(555,root,root) %dir /usr/share/empty
/usr/share/info
%dir /usr/share/locale
%dir /usr/share/man
/usr/share/misc
/usr/share/pixmaps
/usr/share/xsessions
/usr/src
%dir /var
/var/db
/var/games
/var/lib
/var/local
%dir %attr(0775,root,lock) /var/lock
%attr(755,root,root) /var/lock/subsys
/var/cache
/var/empty
/var/log
/var/mail
/var/nis
/var/opt
/var/preserve
/var/run
%dir /var/spool
%attr(755,root,root) /var/spool/lpd
%attr(775,root,mail) /var/spool/mail
%attr(1777,root,root) /var/tmp
/var/yp

%changelog
* Wed May 11 2011 Johnny Hughes <johnny@centos.org> - 2.4.0-3.el5.centos
- Rolled in CentOS Branding

* Thu Oct 01 2009 Ondrej Vasik <ovasik@redhat.com> - 2.4.0-3
- added /usr/src/debug, /usr/src/kernels (#487568)
- added several /usr/share/locale dirs (#487568)
- added /usr/share/man{0,1,3]p to owned files (#487568)
- added ownership for /usr/share/man/<locale>/man<xy> (#487568)
- added URL, project on fedorahosted

* Fri Aug 08 2008 Phil Knirsch <pknirsch@redhat.com> - 2.4.0-2
- Removed /lib/tls and /lib64/tls (#445370)

* Tue Oct 10 2006 Bill Nottingham <notting@redhat.com> - 2.4.0-1
- create and own /usr/share/locale/*/LC_MESSAGES (#196669)

* Tue Oct 10 2006 Phil Knirsch <pknirsch@redhat.com> - 2.3.8-1
- Added the manXx directories to the ownership of filesystem (#208121)

* Wed Jul 12 2006 Jesse Keating <jkeating@redhat.com> - 2.3.7-2.1
- rebuild

* Wed Jun 28 2006 Phil Knirsch <pknirsch@redhat.com> - 2.3.7-2
- Fixed games location according to FHS 2.1 (#165425)
- Added {_libdir}/sse2 to owned files (#192853)
- Added /dev to owned files (#192860)
- Added {_datadir}/icons to owned files (#195911)
- Dropped obsolete /etc/X11/starthere (#191163)

* Fri Feb 10 2006 Jesse Keating <jkeating@redhat.com> - 2.3.7-1.2.1
- bump again for double-long bug on ppc(64)

* Tue Feb 07 2006 Jesse Keating <jkeating@redhat.com> - 2.3.7-1.2
- rebuilt for new gcc4.1 snapshot and glibc changes

* Fri Dec 09 2005 Jesse Keating <jkeating@redhat.com>
- rebuilt

* Thu Nov 17 2005 Bill Nottingham <notting@redhat.com> - 2.3.7-1
- actually, *do* package /usr/lib/X11, etc, but as directories
- remove /usr/X11R6 heirarchy

* Mon Nov  7 2005 Bill Nottingham <notting@redhat.com> - 2.3.6-1
- don't package /usr/lib/X11 or /usr/bin/X11 symlinks

* Fri Aug 19 2005 Bill Nottingham <notting@redhat.com> - 2.3.5-1
- package / (#165797)

* Mon May 23 2005 Bill Nottingham <notting@redhat.com> - 2.3.4-1
- ship /usr/share/games (#158433, <ville.skytta@iki.fi>)

* Thu May  5 2005 Peter Jones <pjones@redhat.com> - 2.3.3-1
- remove /initrd, since mkinitrd doesn't use it anymore by default

* Wed Apr 20 2005 John Dennis <jdennis@redhat.com> - 2.3.2-1
- add /etc/pki, a place to store keys and certificates

* Wed Mar  9 2005 Bill Nottingham <notting@redhat.com> 2.3.1-1
- don't ship /usr/lib64/X11 in general (#147077)

* Thu Aug 12 2004 Bill Nottingham <notting@redhat.com> 2.3.0-1
- add /media, /srv

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Mar 11 2004 Bill Nottingham <notting@redhat.com> 2.2.4-1
- move /selinux here from SysVinit

* Tue Mar 02 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Fri Feb 13 2004 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Thu Jan 15 2004 Bill Nottingham <notting@redhat.com> 2.2.3-1
- move /usr/dict to /usr/share/dict (#113645)
- add /usr/lib/locale, /var/empty (#108686,#113036)
- add */%%{_lib}/tls (#113050)

* Fri Nov 21 2003 Bill Nottingham <notting@redhat.com> 2.2.2-1
- add /sys

* Tue Oct 07 2003 Than Ngo <than@redhat.com> 2.2.1-5
- add /usr/share/xsessions

* Wed Jun 04 2003 Elliot Lee <sopwith@redhat.com>
- rebuilt

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Sun Dec  1 2002 Tim Waugh <twaugh@redhat.com> 2.2.1-2
- Really fix /var/mail

* Thu Nov 28 2002 Bill Nottingham <notting@redhat.com> 2.2.1-1
- fix /var/mail

* Wed Nov 20 2002 Bill Nottingham <notting@redhat.com>
- make arch specific, handle lib/lib64 stuff
- add /usr/libexec, /usr/share/applications

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Aug 20 2001 Bill Nottingham <notting@redhat.com>
- %%ghost /mnt/cdrom, /mnt/floppy (fixes #52046)

* Wed Aug 15 2001 Bill Nottingham <notting@redhat.com>
- add /usr/X11R6/share (#51830)

* Mon Aug 13 2001 Bill Nottingham <notting@redhat.com>
- prereq a particular version of the setup package

* Thu Aug  9 2001 Bill Nottingham <notting@redhat.com>
- remove /mnt/cdrom, /mnt/floppy (updfstab will create them if needed)
- make it noarch again

* Wed Aug  8 2001 Bill Nottingham <notting@redhat.com>
- /var/lock needs to be root.lock, not lock.lock

* Mon Aug  6 2001 Jeff Johnson <jbj@redhat.com>
- lock.lock ownership, 0775 permissions, for /var/lock.

* Tue Jul 17 2001 Bill Nottingham <notting@redhat.com>
- add /etc/sysconfig, /var/yp, /usr/share/pixmaps

* Tue Jul 10 2001 Bill Nottingham <notting@redhat.com>
- add stuff under /etc/X11
- remove extraneous /usr/X11R6/doc (#47490)

* Mon Jun 25 2001 Bill Nottingham <notting@redhat.com>
- don't conflict with rpm

* Fri Jun 22 2001 Bill Nottingham <notting@redhat.com>
- don't own /var/lib/rpm (#43315)
- add some stuff in /usr/local (#36522)

* Thu Jun 21 2001 Bill Nottingham <notting@redhat.com>
- add /initrd

* Thu Jun 07 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- remove noarch
- do not include /mnt/cdrom and /mnt/floppy for s390/s390x

* Mon Apr 16 2001 Bill Nottingham <notting@redhat.com>
- take the group write off of /var/lock

* Fri Jul 21 2000 Bill Nottingham <notting@redhat.com>
- add /usr/share/empty

* Wed Jul 12 2000 Prospector <bugzilla@redhat.com>
- automatic rebuild

* Wed Jun 28 2000 Preston Brown <pbrown@redhat.com>
- remove /usr/doc

* Thu Jun 22 2000 Preston Brown <pbrown@redhat.com>
- remove /usr/info

* Sun Jun 19 2000 Bill Nottingham <notting@redhat.com>
- remove /usr/man

* Sat Jun 17 2000 Bill Nottingham <notting@redhat.com>
- /var/spool/lpd should have normal perms (#12272)

* Tue Jun  6 2000 Bill Nottingham <notting@redhat.com>
- add /etc/skel

* Thu Jun 01 2000 Preston Brown <pbrown@redhat.com>
- add /var/spool/lpd to filesystem, owned by user/group lp, tight permissions

* Tue May 23 2000 Trond Eivind Glomsrd <teg@redhat.com>
- Added /etc/xinetd.d

* Mon May 15 2000 Preston Brown <pbrown@redhat.com>
- /etc/opt, /usr/share/{info,man/man*,misc,doc} (FHS 2.1)
- added /var/games.  Data should move from /var/lib/games to there (FHS 2.1)
- bump version up to 2.0 already!

* Thu Apr 13 2000 Jakub Jelinek <jakub@redhat.com>
- removed /var/state, added /var/opt, /var/mail for FHS 2.1 compliance

* Mon Aug 28 1999 Preston Brown <pbrown@redhat.com>
- added /opt, /var/state, /var/cache for FHS compliance (#3966)

* Sun Mar 21 1999 Cristian Gafton <gafton@redhat.com> 
- auto rebuild in the new build environment (release 4)

* Sun Jan 17 1999 Jeff Johnson <jbj@redhat.com>
- don't carry X11R6.1 as directory on sparc.
- /var/tmp/build root (#811)

* Wed Jan 13 1999 Preston Brown <pbrown@redhat.com>
- font directory didn't belong, which I previously misunderstood.  removed.

* Fri Nov 13 1998 Preston Brown <pbrown@redhat.com>
- /usr/share/fonts/default added.

* Fri Oct  9 1998 Bill Nottingham <notting@redhat.com>
- put /mnt/cdrom back in

* Wed Oct  7 1998 Bill Nottingham <notting@redhat.com>
- Changed /root to 0750

* Wed Aug 05 1998 Erik Troan <ewt@redhat.com>
- added /var/db
- set attributes in the spec file; don't depend on the ones in the cpio
  archive
- use a tarball instead of a cpioball

* Mon Apr 27 1998 Prospector System <bugs@redhat.com>
- translations modified for de, fr, tr

* Tue Sep 09 1997 Erik Troan <ewt@redhat.com>
- made a noarch package

* Wed Jul 09 1997 Erik Troan <ewt@redhat.com>
- added /

* Wed Apr 16 1997 Erik Troan <ewt@redhat.com>
- Changed /proc to 555
- Removed /var/spool/mqueue (which is owned by sendmail)
